{
 Complex Matrix -        .
:                1.00
:                 XXXX Pro (admin@xxxxpro.ru)
 :        http://openpoj.ru/
    : http://openproj.ru/index.php?f=11
     Delphi 6    .

   .
      Complex;
   : A.Re -    ,
A.Im -     (A -  )
       (, 
   )  .

  .
     CMatrix.
          
 SetSize (     ,   
       ).
   : B.Data[i,j],  B -  ,
i -    , j -    .
      : B.Data[i,j].Re  B.Data[i,j].Im
 ,      (, ),
 SetSize  .
 :
TMap -      () ,
CVector -  ,     
     ,    -  
     (      
  ).

    - .  

    ,   
  (,    ).
}

unit CMatrics;

interface
Uses SysUtils;

type
  Complex = record
    Re     : extended;
    Im     : extended;
  end;
  CMatrix = record
    M, N   : integer;  { M -  , N -  }
    Data   : array of array of Complex;
  end;
{$IFNDEF XP_MATRIX}
{$DEFINE XP_CMATRIX}
  TMap = array of integer;
{$ENDIF}
  CVector = array of Complex;

  Function CAdd(const A,B:Complex):Complex; {   }
  Function CSub(const A,B:Complex):Complex; {   }
  Function CMul(const A,B:Complex):Complex; {   }
  Function CDiv(const A,B:Complex):Complex; {   }
  Function CNeg(const A:Complex):Complex; {    }
  Function C1(const A:Complex):Complex; {    }
  Function CCmplx(const A:Complex):Complex; {   : a-i*b }
  Function CZero:Complex; {   }
  Function COne:Complex;  {   }
  Function ToComplex(R,I:extended):Complex; {      }

  Procedure SetSize(var A:CMatrix; M,N:integer); overload; {  }
  Procedure Zero(var A:CMatrix); overload; {   }
  Procedure E(var A:CMatrix); overload; {   }
  Function Transpose(const A:CMatrix):CMatrix; overload; {   }
  Function Add(const A,B:CMatrix):CMatrix; overload; {   }
  Function Sub(const A,B:CMatrix):CMatrix; overload; {   }
  Function Mul(const A,B:CMatrix):CMatrix; overload; {   }

  Function AddValue(const A:CMatrix; Value:Complex):CMatrix; overload; {     }
  Function MulValue(const A:CMatrix; Value:Complex):CMatrix; overload; {     }
  Function Negate(const A:CMatrix):CMatrix; overload; {    }

  Procedure DeleteRow(var A:CMatrix; Row:integer); overload; {   }
  Procedure DeleteCol(var A:CMatrix; Col:integer); overload; {   }
  Procedure DeleteCross(var A:CMatrix; Row:integer); overload; {        }
  Procedure InsertRow(var A:CMatrix; Row:integer); overload; {      }
  Procedure InsertCol(var A:CMatrix; Col:integer); overload; {      }

  Function MapMatrix(const A:CMatrix; const Map:TMap):CMatrix; overload; {        }
  Function MapVector(const A:CMatrix; const Map:TMap):CMatrix; overload; {      }
  Function UnmapMatrix(const A:CMatrix; const Map:TMap):CMatrix; overload; {     }
  Function UnmapVector(const A:CMatrix; const Map:TMap):CMatrix; overload; {      }
  Function SubMatrix(const A:CMatrix; const MapX,MapY:TMap):CMatrix; overload; {  ,      }
  Function RangeMatrix(const A:CMatrix; StartX,EndX,StartY,EndY:integer):CMatrix; overload; {  ,       }

  Function CVectorize(const A:CMatrix):CVector; overload; {    ,     }
  Function UnVectorize(const V:CVector):CMatrix; overload; {  :    }

  Function Inverse(const A1:CMatrix):CMatrix; overload; {     - }
  Function Trace(const A:CMatrix):Complex; overload; {    (  ) }

  Procedure JoinBottom(var A:CMatrix; const B:CMatrix); overload; {    }
  Procedure JoinRight(var A:CMatrix; const B:CMatrix); overload; {    }
  Procedure JoinDiag(var A:CMatrix; const B:CMatrix); overload; {       }

implementation

  Function CAdd(const A,B:Complex):Complex; {   }
  var
    C  : Complex;
  Begin
    C.Re:=A.Re+B.Re;
    C.Im:=A.Im+B.Im;
    Result:=C;
  End;

  Function CSub(const A,B:Complex):Complex; {   }
  var
    C  : Complex;
  Begin
    C.Re:=A.Re-B.Re;
    C.Im:=A.Im-B.Im;
    Result:=C;
  End;

  Function CMul(const A,B:Complex):Complex; {   }
  var
    C  : Complex;
  Begin
    C.Re:=A.Re*B.Re-A.Im*B.Im;
    C.Im:=A.Im*B.Re+A.Re*B.Im;
    Result:=C;
  End;

  Function CDiv(const A,B:Complex):Complex; {   }
  var
    C    : Complex;
    E    : extended;
  Begin
    C:=CMul(A,CCmplx(B));
    E:=sqr(B.Re)+sqr(B.Im);
    C.Re:=C.Re/E;
    C.Im:=C.Im/E;
    Result:=C;
  End;

  Function CNeg(const A:Complex):Complex; {    }
  var
    B  : Complex;
  Begin
    B.Re:=-A.Re;
    B.Im:=-A.Im;
    Result:=B;
  End;

  Function C1(const A:Complex):Complex; {    }
  var
    B  : Complex;
    E  : extended;
  Begin
    B.Re:=A.Re;
    B.Im:=-A.Im;
    E:=sqr(A.Re)+sqr(A.Im);
    B.Re:=B.Re/E;
    B.Im:=B.Im/E;
    Result:=B;
  End;

  Function CCmplx(const A:Complex):Complex; {   : a-i*b }
  var
    B   : Complex;
  Begin
    B.Re:=A.Re;
    B.Im:=-A.Im;
    Result:=B;
  End;

  Function CZero:Complex; {   }
  Begin
    Result.Re:=0;
    Result.Im:=0;
  End;

  Function COne:Complex;  {   }
  Begin
    Result.Re:=1;
    Result.Im:=0;
  End;

  Function ToComplex(R,I:extended):Complex;
  Begin
    Result.Re:=R;
    Result.Im:=I;
  End;

  Procedure SetSize(var A:CMatrix; M,N:integer);
  var
    i  : integer;
  Begin
    A.M:=M;
    A.N:=N;
    SetLength(A.Data,M);
    for i:=0 to M-1 do begin
      SetLength(A.Data[i],N);
    end;
  End;

  Procedure Zero(var A:CMatrix);
  var
    i,j  : integer;
  Begin
   for i:=0 to A.M-1 do for j:=0 to A.N-1 do begin
     A.Data[i,j].Re:=0;
     A.Data[i,j].Im:=0;
   end;
  End;

  Procedure E(var A:CMatrix);
  var
    i  : integer;
  Begin
    if (A.M<>A.N) then Raise Exception.Create('    !');
    Zero(A);
    for i:=0 to A.M-1 do begin
      A.Data[i,i].Re:=1;
      A.Data[i,i].Im:=0;
    end;
  End;

  Function Transpose(const A:CMatrix):CMatrix;
  var
   B      :  CMatrix;
   i,j    :  integer;
  Begin
    SetSize(B,A.N,A.M);
    for i:=0 to A.M-1 do for j:=0 to A.N-1 do B.Data[j,i]:=A.Data[i,j];
    Result:=B;
  End;

  Function Add(const A,B:CMatrix):CMatrix;
  var
    C    :  CMatrix;
    i,j  :  integer;
  Begin
    if ((A.M<>B.M) or (A.N<>B.N)) then Raise Exception.Create('     !');
    SetSize(C,A.M,A.N);
    for i:=0 to A.M-1 do for j:=0 to A.N-1 do C.Data[i,j]:=CAdd(A.Data[i,j],B.Data[i,j]);
    Result:=C;
  End;

  Function Sub(const A,B:CMatrix):CMatrix;
  var
    C    :  CMatrix;
    i,j  :  integer;
  Begin
    if ((A.M<>B.M) or (A.N<>B.N)) then Raise Exception.Create('     !');
    SetSize(C,A.M,A.N);
    for i:=0 to A.M-1 do for j:=0 to A.N-1 do C.Data[i,j]:=CSub(A.Data[i,j],B.Data[i,j]);
    Result:=C;
  End;

  Function Mul(const A,B:CMatrix):CMatrix;
  var
    C       : CMatrix;
    i,j,k   : integer;
  Begin
    if (A.N<>B.M) then Raise Exception.Create('     !');
    SetSize(C,A.M,B.N);
    Zero(C);
    for i:=0 to A.M-1 do for j:=0 to B.N-1 do for k:=0 to A.N-1 do C.Data[i,j]:=CAdd(C.Data[i,j],CMul(A.Data[i,k],B.Data[k,j]));
    Result:=C;
  End;

  Function Inverse(const A1:CMatrix):CMatrix;
  var
    i,j,k    :  integer;
    B,A      :  CMatrix;
    sk, sz   :  Complex;
  Begin
    if (A1.N<>A1.M) then Raise Exception.Create('      !');
    SetSize(B,A1.M,A1.M);
    SetSize(A,A1.M,A1.M);
    for i:=0 to A1.M-1 do for j:=0 to A1.N-1 do A.Data[i,j]:=A1.Data[i,j];
    Zero(B);
    for i:=0 to A.M-1 do B.Data[i,i].Re:=1;
    for i:=0 to A.M-1 do begin
      sk:=C1(A.Data[i,i]);
      for j:=0 to A.M-1 do if (i<>j) then begin
        sz:=CMul(sk,A.Data[j,i]);
        for k:=0 to A.M-1 do A.Data[j,k]:=CSub(A.Data[j,k],CMul(sz,A.Data[i,k]));
        for k:=0 to A.M-1 do B.Data[j,k]:=CSub(B.Data[j,k],CMul(sz,B.Data[i,k]));
      end;
      for k:=0 to A.M-1 do A.Data[i,k]:=CMul(sk,A.Data[i,k]);
      for k:=0 to A.M-1 do B.Data[i,k]:=CMul(sk,B.Data[i,k]);
    end;
    Result:=B;
  End;

  Function Trace(const A:CMatrix):Complex;
  var
    i   : integer;
    res : Complex;
  Begin
    res.Im:=0;
    res.Re:=0;
    if (A.N<>A.M) then Raise Exception.Create('     !');
    for i:=0 to A.M-1 do res:=CAdd(res,A.Data[i,i]);
    Result:=res;
  End;

  Procedure JoinBottom(var A:CMatrix; const B:CMatrix);
  var
    i,j,oldy  : integer;
  Begin
    if (A.N<>B.N) then Raise Exception.Create('     .    !');
    oldy:=A.M;
    SetSize(A,A.M+B.M,A.N);
    for i:=0 to B.M-1 do for j:=0 to B.N-1 do A.Data[i+oldY,j]:=B.Data[i,j];
  End;

  Procedure JoinRight(var A:CMatrix; const B:CMatrix); {    }
  var
   i,j,oldx  : integer;
  Begin
    if (A.M<>B.M) then Raise Exception.Create('     .    !');
    oldx:=A.N;
    SetSize(A,A.M,A.N+B.N);
    for i:=0 to B.M-1 do for j:=0 to B.N-1 do A.Data[i,j+oldX]:=B.Data[i,j];
  End;

  Procedure JoinDiag(var A:CMatrix; const B:CMatrix); {       }
  var
    i,j,oldx,oldy  : integer;
  Begin
    oldY:=A.M;
    oldX:=A.N;
    SetSize(A,A.M+B.M,A.N+B.N);
    for i:=0 to B.M-1 do for j:=0 to B.N-1 do A.Data[i+oldY,j+oldX]:=B.Data[i,j];
    for i:=0 to oldY-1 do for j:=oldX to A.N-1 do begin
      A.Data[i,j].Re:=0;
      A.Data[i,j].Im:=0;      
    end;
    for i:=oldY to A.M-1 do for j:=0 to oldX-1 do begin
      A.Data[i,j].Re:=0;
      A.Data[i,j].Im:=0;
    end;
  End;

  Function Negate(const A:CMatrix):CMatrix;
  var
    i,j   : integer;
    B     : CMatrix;
  Begin
    SetSize(B,A.M,A.N);
    for i:=0 to A.M-1 do for j:=0 to A.N-1 do B.Data[i,j]:=CNeg(A.Data[i,j]);
    Result:=B;
  End;

  Function AddValue(const A:CMatrix; Value:Complex):CMatrix; {     }
  var
    i,j   : integer;
    B     : CMatrix;
  Begin
    SetSize(B,A.M,A.N);
    for i:=0 to A.M-1 do for j:=0 to A.N-1 do B.Data[i,j]:=CAdd(A.Data[i,j],Value);
    Result:=B;
  End;

  Function MulValue(const A:CMatrix; Value:Complex):CMatrix; {     }
  var
    i,j   : integer;
    B     : CMatrix;
  Begin
    SetSize(B,A.M,A.N);
    for i:=0 to A.M-1 do for j:=0 to A.N-1 do B.Data[i,j]:=CMul(A.Data[i,j],Value);
    Result:=B;
  End;

  Procedure DeleteRow(var A:CMatrix; Row:integer); {   }
  var
    i    :  integer;
  Begin
    if (Row>=A.M) then Raise Exception.Create('     !');
    SetLength(A.Data[Row],0);
    for i:=Row+1 to A.M-1 do A.Data[i-1]:=A.Data[i];
    SetLength(A.Data,A.M-1);
    dec(A.M);
  End;

  Procedure DeleteCol(var A:CMatrix; Col:integer); {   }
  var
    i,j   : integer;
  Begin
    if (Col>=A.N) then Raise Exception.Create('     !');
    for i:=0 to A.M-1 do begin
      for j:=Col+1 to A.N-1 do A.Data[i,j-1]:=A.Data[i,j];
      SetLength(A.Data[i],A.N-1);
    end;
    dec(A.N);
  End;

  Procedure DeleteCross(var A:CMatrix; Row:integer); {        }
  Begin
    DeleteRow(A,Row);
    DeleteCol(A,Row);
  End;

  Procedure InsertRow(var A:CMatrix; Row:integer);
  var
    i  : integer;
  Begin
    SetSize(A,A.M+1,A.N);
    for i:=A.M-2 downto Row do A.Data[i+1]:=A.Data[i];
    SetLength(A.Data[Row],A.N);
    for i:=0 to A.N-1 do begin
      A.Data[Row,i].Re:=0;
      A.Data[Row,i].Im:=0;
    end;
  End;

  Procedure InsertCol(var A:CMatrix; Col:integer);
  var
    i,j   : integer;
  Begin
    SetSize(A,A.M,A.N+1);
    for i:=0 to A.M-1 do begin
      for j:=A.N-1 downto Col do A.Data[i,j+1]:=A.Data[i,j];
      A.Data[i,Col].Re:=0;
      A.Data[i,Col].Im:=0;
    end;
  End;

  Function MapMatrix(const A:CMatrix; const Map:TMap):CMatrix; {      }
  var
    i,j        : integer;
    B          : CMatrix;
    CurValue   : integer;
  Begin
    SetSize(B,A.M,A.N);
    for i:=0 to A.M-1 do for j:=0 to A.N-1 do B.Data[i,j]:=A.Data[i,j];
    for i:=0 to length(Map)-2 do begin
     for j:=i to length(Map)-1 do if (Map[j]<Map[i]) then begin
       CurValue:=Map[j];
       Map[j]:=Map[i];
       Map[i]:=CurValue;
     end;
    end;
    for i:=length(Map)-1 downto 0 do DeleteRow(B,Map[i]);
    for i:=length(Map)-1 downto 0 do DeleteCol(B,Map[i]);
    Result:=B;
  End;

  Function MapVector(const A:CMatrix; const Map:TMap):CMatrix; {   }
  var
    i,j        : integer;
    B          : CMatrix;
    CurValue   : integer;
  Begin
    SetSize(B,A.M,A.N);
    for i:=0 to A.M-1 do for j:=0 to A.N-1 do B.Data[i,j]:=A.Data[i,j];
    for i:=0 to length(Map)-2 do begin
     for j:=i to length(Map)-1 do if (Map[j]<Map[i]) then begin
       CurValue:=Map[j];
       Map[j]:=Map[i];
       Map[i]:=CurValue;
     end;
    end;
    for i:=length(Map)-1 downto 0 do DeleteRow(B,Map[i]);
    Result:=B;
  End;

  Function UnmapMatrix(const A:CMatrix; const Map:TMap):CMatrix; {     }
  var
    i,j        : integer;
    B          : CMatrix;
    CurValue   : integer;
  Begin
    SetSize(B,A.M,A.N);
    for i:=0 to A.M-1 do for j:=0 to A.N-1 do B.Data[i,j]:=A.Data[i,j];
    for i:=0 to length(Map)-2 do begin
     for j:=i to length(Map)-1 do if (Map[j]<Map[i]) then begin
       CurValue:=Map[j];
       Map[j]:=Map[i];
       Map[i]:=CurValue;
     end;
    end;
    for i:=0 to length(Map)-1 do InsertRow(B,Map[i]);
    for i:=0 to length(Map)-1 do InsertCol(B,Map[i]);
    Result:=B;
  End;

  Function UnmapVector(const A:CMatrix; const Map:TMap):CMatrix; {       }
  var
    i,j        : integer;
    B          : CMatrix;
    CurValue   : integer;
  Begin
    SetSize(B,A.M,A.N);
    for i:=0 to A.M-1 do for j:=0 to A.N-1 do B.Data[i,j]:=A.Data[i,j];
    for i:=0 to length(Map)-2 do begin
     for j:=i to length(Map)-1 do if (Map[j]<Map[i]) then begin
       CurValue:=Map[j];
       Map[j]:=Map[i];
       Map[i]:=CurValue;
     end;
    end;
    for i:=0 to length(Map)-1 do InsertRow(B,Map[i]);
    Result:=B;
  End;

  Function SubMatrix(const A:CMatrix; const MapX,MapY:TMap):CMatrix; {  ,      }
  var
    i,j       : integer;
    B         : CMatrix;
  Begin
    SetSize(B,Length(MapY),Length(MapX));
    for i:=0 to length(MapY)-1 do begin
      for j:=0 to length(MapX)-1 do B.Data[i,j]:=A.Data[MapY[i],MapX[j]];
    end;
    Result:=B;
  End;

  Function RangeMatrix(const A:CMatrix; StartX,EndX,StartY,EndY:integer):CMatrix; {  ,       }
  var
    i,j   : integer;
    B     : CMatrix;
  Begin
    SetSize(B,EndY-StartY+1,EndX-StartX+1);
    for i:=StartY to EndY do begin
      for j:=StartX to EndX do B.Data[i-StartY,j-StartX]:=A.Data[i,j];
    end;
    Result:=B;
  End;

  Function CVectorize(const A:CMatrix):CVector; {    ,     }
  var
    i,j,k  : integer;
    V      : CVector;
  Begin
    SetLength(V,A.M*A.N+2);
    V[0].Re:=A.M;
    V[0].Im:=A.N;
    k:=1;
    for i:=0 to A.M-1 do for j:=0 to A.N-1 do begin
      V[k]:=A.Data[i,j];
      inc(k);
    end;
    Result:=V;
  End;

  Function UnVectorize(const V:CVector):CMatrix; {  :    }
  var
    i,j,k : integer;
    A     : CMatrix;
  Begin
    SetSize(A,trunc(V[0].Re),trunc(V[0].Im));
    k:=1;
    for i:=0 to A.M-1 do for j:=0 to A.N-1 do begin
      A.Data[i,j]:=V[k];
      inc(k);
    end;
    Result:=A;
  End;

end.
